


/*********************************************************************
 * (C) Copyright 2010 INRIA Nancy Grand Est
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 *********************************************************************/









/*********************************************************************
 *
 * File: search.h
 *
 * Description: headers of routines that search the state space
 *
 *              ADL version, Enforced Hill-climbing enhanced with
 *                           Goal-adders deletion heuristic
 *
 * Author: Joerg Hoffmann 2000
 *
 *********************************************************************/ 






#ifndef _SEARCH_H
#define _SEARCH_H



void do_and_or_search( void );
BfsNode *get_open_leaf_of_best_subtree( void );
BfsNode *SAM_get_open_leaf_of_best_subtree( void );
void set_state_and_hvalues( State *S, BfsNode *tmpbfs );
void update_fvalues_and_markers( BfsNode *open_leaf );
void SAM_update_fvalues_and_markers( BfsNode *open_leaf );
Bool verify_plan( void );
void print_plan( void );
void print_used_nondets( BfsNode *n );



Bool contains_goal( State *S );
void result_to_dest( State *dest, State *source, int ef );
void source_to_dest( State *dest, State *source );
void copy_source_to_dest( State *dest, State *source );
void print_state( State S );



Bool has_duplicate_simple_predecessor( State *S, BfsNode *leaf );
Bool same_state( State *S1, State *S2 );
int state_sum( State *S );



#endif /* _SEARCH_H */
